unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    edInput1: TEdit;
    Label1: TLabel;
    lblResult: TLabel;
    btnConvert: TButton;
    edInput2: TEdit;
    lblInput1: TLabel;
    lblInput2: TLabel;
    RadioGroup1: TRadioGroup;
    procedure btnConvertClick(Sender: TObject);
    procedure ShowFromFootOrMeter;
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ Event handler for Form1.Oncreate
}
procedure TForm1.FormCreate(Sender: TObject);
begin
  ShowFromFootOrMeter;
end;

{ Event handler for RadioGroup1
}
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  ShowFromFootOrMeter;
  lblResult.Caption := 'result...';
  edInput1.SetFocus;
end;

{ Show the components for foot and inch or for meter
}
procedure TForm1.ShowFromFootOrMeter;
begin
  if RadioGroup1.ItemIndex = 0 then begin
    // Show the components for inches
    lblInput2.Visible := True;
    edInput2.Visible := True;
    edInput1.Text := '';
    edInput2.Text := '';
    // Show the names of the starting length units
    lblInput1.Caption := 'foot';
    lblInput2.Caption := 'inch';
  end
  else begin
    // Hide the components for inches
    lblInput2.Visible := False;
    edInput2.Visible := False;
    edInput1.Text := '';
    // Show the name of the starting length unit
    lblInput1.Caption := 'meter';
  end;
end;

{ Event handler for btnConvert
}
procedure TForm1.btnConvertClick(Sender: TObject);
var
  Foot, FootInteger, Inch, Meter: real;
  ResultFoot, ResultInch, ResultMeter: string;
begin
  if RadioGroup1.ItemIndex = 0 then begin
    try
      // Convert the text of the EDITs to numerical values
      if Trim(edInput1.Text) = '' then
        Foot := 0
      else
        Foot := StrToFloat(edInput1.Text);

      if Trim(edInput2.Text) = '' then
        Inch := 0
      else
        Inch := StrToFloat(edInput2.Text);

      // Convert to meter
      Meter := (Foot * 0.3048) + (Inch * 0.3048 / 12);
      { Convert the floating point number to string-format.
        '0.00' is the "Format String", meaning:
        format the result with 2 decimal digits to the right
        of the decimal separator }
      ResultMeter := FormatFloat('0.00', Meter);
      // Show the string in the CAPTION of lblResult
      lblResult.Caption := ResultMeter + ' meter';
    except
      ShowMessage('Invalid number');
    end;
  end
  else begin
    try
      // Convert the text of the EDIT to a numerical value
      if Trim(edInput1.Text) = '' then
        Meter := 0
      else
        Meter := StrToFloat(edInput1.Text);

      // Convert from meter to foot
      Foot := Meter / 0.3048;
      FootInteger := Trunc(Foot);
      Inch := (Foot - FootInteger) * 12;
      { Convert the floating point numbers to string-format.
        '0' is the "Format String", meaning:
        format the result with 0 decimal digits to the right
        of the decimal separator }
      ResultFoot := FormatFloat('0', FootInteger);
      ResultInch := FormatFloat('0', Inch);
      // Show the result in the CAPTION of lblResult
      LblResult.Caption := ResultFoot + ' foot ' + ResultInch + ' inch';
    except
      ShowMessage('Invalid number');
    end;
  end;
end;

end.
